<?php

declare(strict_types=1);

namespace App\Controller;

use App\Enum\StockState;
use App\Service\InventoryService;
use App\ValueObject\DrinkStock;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

#[Route(path: '/', name: 'app_index')]
final class Index extends AbstractController
{

    public function __invoke(): Response
    {
        $drinkStocks = $this->inventoryService->getAllDrinkTypesWithStockLevels();

        $low = array_filter(
            $drinkStocks,
            fn(DrinkStock $stock): bool => $stock->stock === StockState::LOW || $stock->stock === StockState::CRITICAL,
        );

        return $this->render('index.html.twig', [
            'drinkStocks' => $drinkStocks,
            'low' => $low,
        ]);
    }
}
