<?php

use App\Entity\DrinkType;
use App\Entity\PropertyChangeLog;
use Doctrine\ORM\EntityManagerInterface;

test('Update Listener', function () {
    $drinkType = new DrinkType();
    $drinkType->setName('test');
    $drinkType->setWantedStock(10);
    $drinkType->setCurrentStock(10);

    $em = $this->get(EntityManagerInterface::class);

    $em->persist($drinkType);
    $em->flush();

    $propertyLogRepository = $em->getRepository(PropertyChangeLog::class);
    $logs = $propertyLogRepository->findBy(['entityClass' => DrinkType::class]);
    expect($logs)->toHaveCount(2);

    $drinkType->setWantedStock(15);
    $em->persist($drinkType);
    $em->flush();

    $logs = $propertyLogRepository->findBy(['entityClass' => DrinkType::class]);
    expect($logs)->toHaveCount(3);

    $drinkType->setCurrentStock(15);
    $em->persist($drinkType);
    $em->flush();

    $logs = $propertyLogRepository->findBy(['entityClass' => DrinkType::class]);
    expect($logs)->toHaveCount(4);

    $drinkType->setDescription('test');
    $em->persist($drinkType);
    $em->flush();
    $logs = $propertyLogRepository->findBy(['entityClass' => DrinkType::class]);
    expect($logs)->toHaveCount(4);
});
